# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/display/mediatek/mediatek,ovl-2l.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Mediatek display overlay 2 layer

maintainers:
  - Chun-Kuang Hu <chunkuang.hu@kernel.org>
  - Philipp Zabel <p.zabel@pengutronix.de>

description: |
  Mediatek display overlay 2 layer, namely OVL-2L, provides 2 more layer
  for OVL.
  OVL-2L device node must be siblings to the central MMSYS_CONFIG node.
  For a description of the MMSYS_CONFIG binding, see
  Documentation/devicetree/bindings/arm/mediatek/mediatek,mmsys.yaml
  for details.

properties:
  compatible:
    oneOf:
      - items:
          - const: mediatek,mt8183-disp-ovl-2l
      - items:
          - const: mediatek,mt8192-disp-ovl-2l

  reg:
    maxItems: 1

  interrupts:
    maxItems: 1

  power-domains:
    description: A phandle and PM domain specifier as defined by bindings of
      the power controller specified by phandle. See
      Documentation/devicetree/bindings/power/power-domain.yaml for details.

  clocks:
    items:
      - description: OVL-2L Clock

  iommus:
    description:
      This property should point to the respective IOMMU block with master port as argument,
      see Documentation/devicetree/bindings/iommu/mediatek,iommu.yaml for details.

  mediatek,larb:
    description:
      This property should contain a phandle pointing to the local arbiter devices defined in
      Documentation/devicetree/bindings/memory-controllers/mediatek,smi-larb.yaml.
      It must sort according to the local arbiter index, like larb0, larb1, larb2...
    $ref: /schemas/types.yaml#/definitions/phandle-array
    minItems: 1
    maxItems: 32

  mediatek,gce-client-reg:
    description: The register of client driver can be configured by gce with
      4 arguments defined in this property, such as phandle of gce, subsys id,
      register offset and size. Each GCE subsys id is mapping to a client
      defined in the header include/dt-bindings/gce/<chip>-gce.h.
    $ref: /schemas/types.yaml#/definitions/phandle-array
    maxItems: 1

required:
  - compatible
  - reg
  - interrupts
  - power-domains
  - clocks
  - iommus

additionalProperties: false

examples:
  - |

    ovl_2l0: ovl@14009000 {
        compatible = "mediatek,mt8183-disp-ovl-2l";
        reg = <0 0x14009000 0 0x1000>;
        interrupts = <GIC_SPI 226 IRQ_TYPE_LEVEL_LOW>;
        power-domains = <&spm MT8183_POWER_DOMAIN_DISP>;
        clocks = <&mmsys CLK_MM_DISP_OVL0_2L>;
        iommus = <&iommu M4U_PORT_DISP_2L_OVL0_LARB0>;
        mediatek,larb = <&larb0>;
        mediatek,gce-client-reg = <&gce SUBSYS_1400XXXX 0x9000 0x1000>;
    };
